use std::marker::PhantomData;

use crate::message::Message;

#[derive(Clone, Debug, PartialEq)]
#[non_exhaustive]
pub enum RecvError {
    Empty,
    Closed,
    Lagged,
}

pub struct Subscription<T> {
    _phantom: PhantomData<T>,
}

impl<T: Message> Subscription<T> {
    pub async fn recv(&mut self) -> Result<T, RecvError> {
        todo!()
    }

    pub fn recv_blocking(&mut self) -> Result<T, RecvError> {
        todo!()
    }

    pub fn try_recv(&mut self) -> Result<T, RecvError> {
        todo!()
    }
}
