use std::marker::PhantomData;

use crate::message::Message;

#[derive(Clone, Debug, PartialEq)]
#[non_exhaustive]
pub enum SendError {
    NoListeners,
}

pub struct Publication<T> {
    _phantom: PhantomData<T>,
}

impl<T: Message> Publication<T> {
    pub fn send(&mut self, message: T) -> Result<(), SendError> {
        let _ = message;
        todo!()
    }
}
